<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTag_specs ArrayType
 * @subpackage Arrays
 */
class ArrayOfTag_specs extends AbstractStructArrayBase
{
    /**
     * The tag_specs
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Tag_specs[]
     */
    public $tag_specs;
    /**
     * Constructor method for ArrayOfTag_specs
     * @uses ArrayOfTag_specs::setTag_specs()
     * @param \StructType\Tag_specs[] $tag_specs
     */
    public function __construct(array $tag_specs = array())
    {
        $this
            ->setTag_specs($tag_specs);
    }
    /**
     * Get tag_specs value
     * @return \StructType\Tag_specs[]|null
     */
    public function getTag_specs()
    {
        return $this->tag_specs;
    }
    /**
     * This method is responsible for validating the values passed to the setTag_specs method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTag_specs method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTag_specsForArrayConstraintsFromSetTag_specs(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTag_specsTag_specsItem) {
            // validation for constraint: itemType
            if (!$arrayOfTag_specsTag_specsItem instanceof \StructType\Tag_specs) {
                $invalidValues[] = is_object($arrayOfTag_specsTag_specsItem) ? get_class($arrayOfTag_specsTag_specsItem) : sprintf('%s(%s)', gettype($arrayOfTag_specsTag_specsItem), var_export($arrayOfTag_specsTag_specsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The tag_specs property can only contain items of type \StructType\Tag_specs, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set tag_specs value
     * @throws \InvalidArgumentException
     * @param \StructType\Tag_specs[] $tag_specs
     * @return \ArrayType\ArrayOfTag_specs
     */
    public function setTag_specs(array $tag_specs = array())
    {
        // validation for constraint: array
        if ('' !== ($tag_specsArrayErrorMessage = self::validateTag_specsForArrayConstraintsFromSetTag_specs($tag_specs))) {
            throw new \InvalidArgumentException($tag_specsArrayErrorMessage, __LINE__);
        }
        $this->tag_specs = $tag_specs;
        return $this;
    }
    /**
     * Add item to tag_specs value
     * @throws \InvalidArgumentException
     * @param \StructType\Tag_specs $item
     * @return \ArrayType\ArrayOfTag_specs
     */
    public function addToTag_specs(\StructType\Tag_specs $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Tag_specs) {
            throw new \InvalidArgumentException(sprintf('The tag_specs property can only contain items of type \StructType\Tag_specs, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->tag_specs[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Tag_specs|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Tag_specs|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Tag_specs|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Tag_specs|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Tag_specs|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string tag_specs
     */
    public function getAttributeName()
    {
        return 'tag_specs';
    }
}
