<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for avl_tag StructType
 * @subpackage Structs
 */
class Avl_tag extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Id;
    /**
     * The account
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $account;
    /**
     * The fleet
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $fleet;
    /**
     * The index
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $index;
    /**
     * The parent
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $parent;
    /**
     * The scope
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $scope;
    /**
     * The tag
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $tag;
    /**
     * Constructor method for avl_tag
     * @uses Avl_tag::setId()
     * @uses Avl_tag::setAccount()
     * @uses Avl_tag::setFleet()
     * @uses Avl_tag::setIndex()
     * @uses Avl_tag::setParent()
     * @uses Avl_tag::setScope()
     * @uses Avl_tag::setTag()
     * @param int $id
     * @param int $account
     * @param int $fleet
     * @param int $index
     * @param int $parent
     * @param string $scope
     * @param string $tag
     */
    public function __construct($id = null, $account = null, $fleet = null, $index = null, $parent = null, $scope = null, $tag = null)
    {
        $this
            ->setId($id)
            ->setAccount($account)
            ->setFleet($fleet)
            ->setIndex($index)
            ->setParent($parent)
            ->setScope($scope)
            ->setTag($tag);
    }
    /**
     * Get Id value
     * @return int
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \StructType\Avl_tag
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get account value
     * @return int
     */
    public function getAccount()
    {
        return $this->account;
    }
    /**
     * Set account value
     * @param int $account
     * @return \StructType\Avl_tag
     */
    public function setAccount($account = null)
    {
        // validation for constraint: int
        if (!is_null($account) && !(is_int($account) || ctype_digit($account))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($account, true), gettype($account)), __LINE__);
        }
        $this->account = $account;
        return $this;
    }
    /**
     * Get fleet value
     * @return int
     */
    public function getFleet()
    {
        return $this->fleet;
    }
    /**
     * Set fleet value
     * @param int $fleet
     * @return \StructType\Avl_tag
     */
    public function setFleet($fleet = null)
    {
        // validation for constraint: int
        if (!is_null($fleet) && !(is_int($fleet) || ctype_digit($fleet))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($fleet, true), gettype($fleet)), __LINE__);
        }
        $this->fleet = $fleet;
        return $this;
    }
    /**
     * Get index value
     * @return int
     */
    public function getIndex()
    {
        return $this->index;
    }
    /**
     * Set index value
     * @param int $index
     * @return \StructType\Avl_tag
     */
    public function setIndex($index = null)
    {
        // validation for constraint: int
        if (!is_null($index) && !(is_int($index) || ctype_digit($index))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($index, true), gettype($index)), __LINE__);
        }
        $this->index = $index;
        return $this;
    }
    /**
     * Get parent value
     * @return int
     */
    public function getParent()
    {
        return $this->parent;
    }
    /**
     * Set parent value
     * @param int $parent
     * @return \StructType\Avl_tag
     */
    public function setParent($parent = null)
    {
        // validation for constraint: int
        if (!is_null($parent) && !(is_int($parent) || ctype_digit($parent))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($parent, true), gettype($parent)), __LINE__);
        }
        $this->parent = $parent;
        return $this;
    }
    /**
     * Get scope value
     * @return string|null
     */
    public function getScope()
    {
        return $this->scope;
    }
    /**
     * Set scope value
     * @param string $scope
     * @return \StructType\Avl_tag
     */
    public function setScope($scope = null)
    {
        // validation for constraint: string
        if (!is_null($scope) && !is_string($scope)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($scope, true), gettype($scope)), __LINE__);
        }
        $this->scope = $scope;
        return $this;
    }
    /**
     * Get tag value
     * @return string|null
     */
    public function getTag()
    {
        return $this->tag;
    }
    /**
     * Set tag value
     * @param string $tag
     * @return \StructType\Avl_tag
     */
    public function setTag($tag = null)
    {
        // validation for constraint: string
        if (!is_null($tag) && !is_string($tag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tag, true), gettype($tag)), __LINE__);
        }
        $this->tag = $tag;
        return $this;
    }
}
