<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CmdStatusResponse StructType
 * @subpackage Structs
 */
class CmdStatusResponse extends AbstractStructBase
{
    /**
     * The error_code
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $error_code;
    /**
     * The cmdRetries
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $cmdRetries;
    /**
     * The cmdSecs
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $cmdSecs;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The cmdResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $cmdResponse;
    /**
     * The cmdDescr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $cmdDescr;
    /**
     * The cmdReady
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $cmdReady;
    /**
     * The cmdAck
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $cmdAck;
    /**
     * Constructor method for CmdStatusResponse
     * @uses CmdStatusResponse::setError_code()
     * @uses CmdStatusResponse::setCmdRetries()
     * @uses CmdStatusResponse::setCmdSecs()
     * @uses CmdStatusResponse::setStatus()
     * @uses CmdStatusResponse::setDescription()
     * @uses CmdStatusResponse::setCmdResponse()
     * @uses CmdStatusResponse::setCmdDescr()
     * @uses CmdStatusResponse::setCmdReady()
     * @uses CmdStatusResponse::setCmdAck()
     * @param int $error_code
     * @param int $cmdRetries
     * @param int $cmdSecs
     * @param string $status
     * @param string $description
     * @param string $cmdResponse
     * @param string $cmdDescr
     * @param string $cmdReady
     * @param string $cmdAck
     */
    public function __construct($error_code = null, $cmdRetries = null, $cmdSecs = null, $status = null, $description = null, $cmdResponse = null, $cmdDescr = null, $cmdReady = null, $cmdAck = null)
    {
        $this
            ->setError_code($error_code)
            ->setCmdRetries($cmdRetries)
            ->setCmdSecs($cmdSecs)
            ->setStatus($status)
            ->setDescription($description)
            ->setCmdResponse($cmdResponse)
            ->setCmdDescr($cmdDescr)
            ->setCmdReady($cmdReady)
            ->setCmdAck($cmdAck);
    }
    /**
     * Get error_code value
     * @return int
     */
    public function getError_code()
    {
        return $this->error_code;
    }
    /**
     * Set error_code value
     * @param int $error_code
     * @return \StructType\CmdStatusResponse
     */
    public function setError_code($error_code = null)
    {
        // validation for constraint: int
        if (!is_null($error_code) && !(is_int($error_code) || ctype_digit($error_code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($error_code, true), gettype($error_code)), __LINE__);
        }
        $this->error_code = $error_code;
        return $this;
    }
    /**
     * Get cmdRetries value
     * @return int
     */
    public function getCmdRetries()
    {
        return $this->cmdRetries;
    }
    /**
     * Set cmdRetries value
     * @param int $cmdRetries
     * @return \StructType\CmdStatusResponse
     */
    public function setCmdRetries($cmdRetries = null)
    {
        // validation for constraint: int
        if (!is_null($cmdRetries) && !(is_int($cmdRetries) || ctype_digit($cmdRetries))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($cmdRetries, true), gettype($cmdRetries)), __LINE__);
        }
        $this->cmdRetries = $cmdRetries;
        return $this;
    }
    /**
     * Get cmdSecs value
     * @return int
     */
    public function getCmdSecs()
    {
        return $this->cmdSecs;
    }
    /**
     * Set cmdSecs value
     * @param int $cmdSecs
     * @return \StructType\CmdStatusResponse
     */
    public function setCmdSecs($cmdSecs = null)
    {
        // validation for constraint: int
        if (!is_null($cmdSecs) && !(is_int($cmdSecs) || ctype_digit($cmdSecs))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($cmdSecs, true), gettype($cmdSecs)), __LINE__);
        }
        $this->cmdSecs = $cmdSecs;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\CmdStatusResponse
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\CmdStatusResponse
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get cmdResponse value
     * @return string|null
     */
    public function getCmdResponse()
    {
        return $this->cmdResponse;
    }
    /**
     * Set cmdResponse value
     * @param string $cmdResponse
     * @return \StructType\CmdStatusResponse
     */
    public function setCmdResponse($cmdResponse = null)
    {
        // validation for constraint: string
        if (!is_null($cmdResponse) && !is_string($cmdResponse)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cmdResponse, true), gettype($cmdResponse)), __LINE__);
        }
        $this->cmdResponse = $cmdResponse;
        return $this;
    }
    /**
     * Get cmdDescr value
     * @return string|null
     */
    public function getCmdDescr()
    {
        return $this->cmdDescr;
    }
    /**
     * Set cmdDescr value
     * @param string $cmdDescr
     * @return \StructType\CmdStatusResponse
     */
    public function setCmdDescr($cmdDescr = null)
    {
        // validation for constraint: string
        if (!is_null($cmdDescr) && !is_string($cmdDescr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cmdDescr, true), gettype($cmdDescr)), __LINE__);
        }
        $this->cmdDescr = $cmdDescr;
        return $this;
    }
    /**
     * Get cmdReady value
     * @return string|null
     */
    public function getCmdReady()
    {
        return $this->cmdReady;
    }
    /**
     * Set cmdReady value
     * @param string $cmdReady
     * @return \StructType\CmdStatusResponse
     */
    public function setCmdReady($cmdReady = null)
    {
        // validation for constraint: string
        if (!is_null($cmdReady) && !is_string($cmdReady)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cmdReady, true), gettype($cmdReady)), __LINE__);
        }
        $this->cmdReady = $cmdReady;
        return $this;
    }
    /**
     * Get cmdAck value
     * @return string|null
     */
    public function getCmdAck()
    {
        return $this->cmdAck;
    }
    /**
     * Set cmdAck value
     * @param string $cmdAck
     * @return \StructType\CmdStatusResponse
     */
    public function setCmdAck($cmdAck = null)
    {
        // validation for constraint: string
        if (!is_null($cmdAck) && !is_string($cmdAck)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cmdAck, true), gettype($cmdAck)), __LINE__);
        }
        $this->cmdAck = $cmdAck;
        return $this;
    }
}
