<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ItPointArrivalResponse StructType
 * @subpackage Structs
 */
class ItPointArrivalResponse extends AbstractStructBase
{
    /**
     * The error_code
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $error_code;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The itPointArrivals
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfItPointArrival
     */
    public $itPointArrivals;
    /**
     * Constructor method for ItPointArrivalResponse
     * @uses ItPointArrivalResponse::setError_code()
     * @uses ItPointArrivalResponse::setStatus()
     * @uses ItPointArrivalResponse::setDescription()
     * @uses ItPointArrivalResponse::setItPointArrivals()
     * @param int $error_code
     * @param string $status
     * @param string $description
     * @param \ArrayType\ArrayOfItPointArrival $itPointArrivals
     */
    public function __construct($error_code = null, $status = null, $description = null, \ArrayType\ArrayOfItPointArrival $itPointArrivals = null)
    {
        $this
            ->setError_code($error_code)
            ->setStatus($status)
            ->setDescription($description)
            ->setItPointArrivals($itPointArrivals);
    }
    /**
     * Get error_code value
     * @return int
     */
    public function getError_code()
    {
        return $this->error_code;
    }
    /**
     * Set error_code value
     * @param int $error_code
     * @return \StructType\ItPointArrivalResponse
     */
    public function setError_code($error_code = null)
    {
        // validation for constraint: int
        if (!is_null($error_code) && !(is_int($error_code) || ctype_digit($error_code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($error_code, true), gettype($error_code)), __LINE__);
        }
        $this->error_code = $error_code;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\ItPointArrivalResponse
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\ItPointArrivalResponse
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get itPointArrivals value
     * @return \ArrayType\ArrayOfItPointArrival|null
     */
    public function getItPointArrivals()
    {
        return $this->itPointArrivals;
    }
    /**
     * Set itPointArrivals value
     * @param \ArrayType\ArrayOfItPointArrival $itPointArrivals
     * @return \StructType\ItPointArrivalResponse
     */
    public function setItPointArrivals(\ArrayType\ArrayOfItPointArrival $itPointArrivals = null)
    {
        $this->itPointArrivals = $itPointArrivals;
        return $this;
    }
}
